unit uJJMgt;

interface

uses
  uJJThread, uSimpleBase, uJJApple, System.SysUtils;

type

  TJJMgt = class;

  TMgtStatus = (mtOK, mtErr);
  TOnMgtStatus = procedure(Sender: TJJMgt; AStatus: TMgtStatus) of object;

  TJJMgt = class(TSimpleBase)
  private
    FWorkTimes: integer;
    FWorkOKCount: integer;
    FJJThreadList: TJJThreadList;
    FJJAppleList: TJJAppleList;
    procedure OnJJStatusTing(Sender: TJJThread; AStatus: TJJStatus);
    procedure DispSpliteLine();
  protected
    procedure DoOnMgtStatus(AStatus: TMgtStatus);
  public
    constructor Create;
    destructor Destroy; override;
    procedure StartWork;
  public
    OnMgtStatus: TOnMgtStatus;
  end;

implementation

{ TJJMgt }

constructor TJJMgt.Create;
var
  J: TJJThread;
begin
  inherited;
  FJJThreadList := TJJThreadList.Create;
  FJJThreadList.Init(5);
  for J in FJJThreadList do
  begin
    J.OnStatusMsg := self.OnDispMsgTing;
    J.OnJJStatus := self.OnJJStatusTing;
  end;

  FJJAppleList := TJJAppleList.Create;
  FJJAppleList.Init(100);

end;

destructor TJJMgt.Destroy;
begin
  // Ҫ߳ȫֹͣ󣬲ִд˴
  FJJThreadList.Free;
  inherited;
end;

procedure TJJMgt.DispSpliteLine;
begin
  DispMsg('------------------------------------------------------------');
end;

procedure TJJMgt.DoOnMgtStatus(AStatus: TMgtStatus);
begin
  if Assigned(OnMgtStatus) then
    OnMgtStatus(self, AStatus);
end;

procedure TJJMgt.OnJJStatusTing(Sender: TJJThread; AStatus: TJJStatus);
var
  LJJApple: TJJApple;
begin

  FJJAppleList.Lock;
  try

    if AStatus = jsGetData then
    begin

      inc(FWorkTimes);
      Sender.ForceErr := (FWorkTimes mod 18) = 0; // Ƶ

      LJJApple := FJJAppleList.GetUnSelectApple;

      if Assigned(LJJApple) then
        LJJApple.Selected := true;

      Sender.JJApple := LJJApple;

    end;

    if AStatus = jsNoData then
    begin
      Sender.StopThread; // ݣֹͣ
    end;

    if AStatus = jsErr then
    begin
      DispMsg('ģ̳߳!');
      Sender.JJApple.Selected := false; // Ż List 
      Sender.JJApple.Worked := false;

      DispMsg(Sender.JJApple.ToDetail);
      DispMsg('ѷŻList');
      DispMsg('****************************************');
    end;

    if AStatus = jsFinished then
    begin

      Sender.JJApple.Worked := true;
      inc(FWorkOKCount);

      DispMsg(Sender.JJApple.ToDetail);

      DispMsg('ܹ:' + IntTostr(FJJAppleList.Count) + ',ɹ:' + IntTostr(FWorkOKCount) + ',ִд:' +
        IntTostr(FWorkTimes));

      DispSpliteLine;

      if FWorkOKCount = FJJAppleList.Count then
      begin
        DispMsg('ȫ!');
        DoOnMgtStatus(mtOK);
      end;

    end;

  finally
    FJJAppleList.Unlock;
  end;

end;

procedure TJJMgt.StartWork;
begin
  FWorkTimes := 0;
  FWorkOKCount := 0;
  FJJAppleList.Init(100); // 100
  FJJAppleList.Shuffle; // ˳;
  FJJThreadList.Init(5); // 5߳
  FJJThreadList.StartWork;
end;

end.
