unit uJJThread;

interface

uses
  uSimpleList, uSimpleThread, uJJApple;

type
  TJJThread = class;

  TJJStatus = (jsGetData, jsFinished, jsErr, jsNoData, jsStoped);

  TOnJJStatus = procedure(Sender: TJJThread; AStatus: TJJStatus) of object;

  TJJThread = class(TSimpleThread)
  private
    procedure WorkJJ;
    procedure DoWorkJJ;
  protected
    procedure DoOnJJStatus(AStatus: TJJStatus);
  public
    constructor Create;
    procedure StartThread; override;
  public
    OnJJStatus: TOnJJStatus;
    JJApple: TJJApple;
    ForceErr: boolean; // ģ̳߳
    Index: integer;
  end;

  TJJThreadList = class(TClassSimpleList<TJJThread>)
  public
    procedure Init(ACount: integer);
    procedure StartWork();
  end;

implementation

{ TJJThread }

constructor TJJThread.Create;
begin
  inherited Create(false);
end;

procedure TJJThread.DoOnJJStatus(AStatus: TJJStatus);
begin
  if Assigned(OnJJStatus) then
    OnJJStatus(self, AStatus);
end;

procedure TJJThread.DoWorkJJ;
var
  LSum: integer;
  I: integer;
begin

  if WaitStop then // ֹ߳ͣ
    exit;

  JJApple := nil;

  DoOnJJStatus(jsGetData);

  if Assigned(JJApple) then
  begin

    if ForceErr then // ģ
    begin
      DoOnJJStatus(jsErr);
    end
    else
    begin

      LSum := 0;
      for I := 1 to JJApple.Param do
      begin
        LSum := LSum + I;
      end;

      JJApple.Worked := true;
      JJApple.Sum := LSum;
      DoOnJJStatus(jsFinished);

    end;

  end
  else
    DoOnJJStatus(jsNoData);

  SleepExceptStopped(100);
  WorkJJ;

end;

procedure TJJThread.StartThread;
begin
  inherited;
  WorkJJ;
end;

procedure TJJThread.WorkJJ;
begin
  ExeProcInThread(DoWorkJJ);
end;

{ TJJThreadList }

procedure TJJThreadList.Init(ACount: integer);
var
  I: integer;
  J: TJJThread;
begin
  for I := self.Count to ACount - 1 do
  begin
    J := AddNewOne;
    J.Index := I;
  end;
end;

procedure TJJThreadList.StartWork;
var
  q: TJJThread;
begin

  for q in self do
  begin
    q.StartThread;
  end;

end;

end.
