unit uSimpleThread;

interface

uses
  System.Classes, System.SysUtils, System.SyncObjs;

type

  // ʾϢ,÷ DoOnStatusMsg(AMsg);
  TOnStatusMsg = procedure(AMsg: string) of object;

  // ʾϢ,һʾϢ,÷ DoOnDebugMsg(AMsg);
  TOnDebugMsg = TOnStatusMsg;

  TSimpleThread = class(TThread)
  public type // "ִй"
    TSimpleProc = procedure; // ͨ, procedure DoSomeThing;
    TObjectProc = procedure of object; // , TXxxx.DoSomeThing; õö
    TAnonymousProc = reference to procedure; // 
  private type
    TProcKind = (pkSimple, pkObject, pkAnonymous); // "ִй"
  private

    FGeneralProc: TSimpleProc;
    FObjProc: TObjectProc;
    FAnoProc: TAnonymousProc;
    FProcKind: TProcKind;
    FAllowedActiveX: boolean; // Ƿ֧߳ Com ,Ҫ߳з IE Ļ趨Ϊ True

    FTagID: integer; // ߳һ,̳߳صʱ

    procedure SelfStart; // ߳
    procedure DoExecute; // еĴǡ߳̿ռ䡱
    procedure DoOnException(e: exception); // 쳣Ϣʾ  DoOnDebugMsg(AMsg);

  protected

    FEvent: TEvent; // һź
    FWaitStop: boolean; // ־ڼ̳ʹȷ߳Ƿֹͣ
    f: TLightweightEvent;

    procedure DoOnStatusMsg(AMsg: string); // ʾͨϢ
    procedure DoOnDebugMsg(AMsg: string); // ʾʽϢ

    procedure Execute; override; //  TThread.Execute

    procedure OnThreadProcErr(e: exception); virtual; // 쳣¼

    procedure WaitThreadStop; // ȴ߳̽

    procedure BeforeExecute; virtual; // 4procڼ̳ʹ
    procedure PauseExecute; virtual; // TLimpidThreadPool ʵ̳߳عܡ
    procedure ProcessExecute; virtual;
    Procedure AfterExecute; virtual;

  public

    // ıһ Create Ĳ,AllowedActiveXǷ̴߳ Com
    constructor Create(AllowedActiveX: boolean = false); reintroduce;
    destructor Destroy; override;

    procedure BeforeDestruction; override;

    procedure ExeProcInThread(AProc: TSimpleProc); overload; // ,Ľӿڡ
    procedure ExeProcInThread(AProc: TObjectProc); overload;
    procedure ExeProcInThread(AProc: TAnonymousProc); overload;

    procedure SleepExceptStopped(ATimeOut: Cardinal); // ߴˣҪһ¡
    { ʱ߳ûʱͻϢһǣϢʱ򣬿ܻյ˳̵ָ߳
      ˺ϢʱҲһָֹͣ
    }

    procedure StartThread; virtual;
    { ̣߳һֻһΡ
      Ժ̵߳Ӧ¼ִ
    }

    procedure StopThread; virtual; // ֹͣ߳
    property WaitStop: boolean read FWaitStop;

  public
    TagID: integer;
    OnStatusMsg: TOnStatusMsg;
    OnDebugMsg: TOnDebugMsg;
  end;

implementation

{$IF DEFINED(ANDROID) OR (DEFINED(IOS))}
{$ELSE}

uses
  Winapi.ActiveX;
{$ENDIF}

procedure TSimpleThread.AfterExecute;
begin
end;

procedure TSimpleThread.BeforeDestruction;
begin
  inherited;
  WaitThreadStop;
end;

procedure TSimpleThread.BeforeExecute;
begin
end;

constructor TSimpleThread.Create(AllowedActiveX: boolean);
begin
  inherited Create(false);
  FAllowedActiveX := AllowedActiveX;
  FreeOnTerminate := false; // ҪֶFree߳
  FEvent := TEvent.Create(nil, true, false, '');
end;

destructor TSimpleThread.Destroy;
begin
  // ִ Destroy ֮ǰִ BeforeDestruction
  FEvent.Free;
  inherited;
end;

procedure TSimpleThread.DoExecute; // ˺ִеĴ,ڶ߳̿ռ
begin
  BeforeExecute;
  repeat

    PauseExecute;

    FEvent.WaitFor;
    FEvent.ResetEvent; // ´waitfor һֱ
    { ﳢ˺ܶЩ SelfStart гͻ޸Ĳʹ֤
      ûбҪ,Ϊֻ StartThread һΣʣµĽ߳Ӧ¼
    }

    ProcessExecute;

    if not Terminated then // ߳Ҫ˳
    begin

      try

        case FProcKind of
          pkSimple:
            FGeneralProc;
          pkObject:
            FObjProc;
          pkAnonymous:
            FAnoProc;
        end;

      except

        on e: exception do
        begin
          DoOnException(e);
        end;

      end;

    end;

  until Terminated;
  AfterExecute;
  // еͱʾ̲߳ˡҲزȥˣͷԴˡ
end;

procedure TSimpleThread.DoOnDebugMsg(AMsg: string);
begin
  if Assigned(OnDebugMsg) then
    OnDebugMsg(AMsg);
end;

procedure TSimpleThread.DoOnException(e: exception);
var
  sErrMsg: string;
begin
  sErrMsg := 'ClassName:' + ClassName + #13#10;
  sErrMsg := sErrMsg + 'TagID:' + IntToStr(FTagID) + #13#10;
  sErrMsg := sErrMsg + 'ErrMsg:' + e.Message + #13#10;
  DoOnDebugMsg(sErrMsg);
  OnThreadProcErr(e);
end;

procedure TSimpleThread.DoOnStatusMsg(AMsg: string);
begin
  if Assigned(OnStatusMsg) then
    OnStatusMsg(AMsg);
end;

procedure TSimpleThread.Execute;
begin
  // Ƿ֧ Com
{$IF DEFINED(ANDROID) OR (DEFINED(IOS))}
  DoExecute;
{$ELSE}
  if FAllowedActiveX then
  begin
    CoInitialize(nil);
    try
      DoExecute;
    finally
      CoUninitialize;
    end;
  end
  else
    DoExecute;
{$ENDIF}
end;

procedure TSimpleThread.ExeProcInThread(AProc: TSimpleProc);
begin
  FGeneralProc := AProc;
  FProcKind := pkSimple;
  SelfStart;
end;

procedure TSimpleThread.ExeProcInThread(AProc: TObjectProc);
begin
  FObjProc := AProc;
  FProcKind := pkObject;
  SelfStart;
end;

procedure TSimpleThread.ExeProcInThread(AProc: TAnonymousProc);
begin
  FAnoProc := AProc;
  FProcKind := pkAnonymous;
  SelfStart;
end;

procedure TSimpleThread.OnThreadProcErr(e: exception);
begin;
end;

procedure TSimpleThread.PauseExecute;
begin
end;

procedure TSimpleThread.ProcessExecute;
begin
end;

procedure TSimpleThread.SelfStart;
begin
  // γԣдû
  if FEvent.WaitFor(0) <> wrSignaled then
    FEvent.SetEvent; // waitfor ٵ
end;

procedure TSimpleThread.StopThread;
begin
  // ̳ĴУҪ FWaitStop ߳̽
  FWaitStop := true;
end;

procedure TSimpleThread.SleepExceptStopped(ATimeOut: Cardinal);
var
  BOldTime: Cardinal;
  LDiff: integer;
begin
  // sleep ʱ˳ָ,ȷ߳˳˳
  BOldTime := GetTickCount;
  while not WaitStop do
  begin
    LDiff := ATimeOut - (GetTickCount - BOldTime);
    if LDiff <= 0 then
      Break
    else if LDiff < 50 then
      Sleep(LDiff)
    else
      Sleep(50);
  end;
end;

procedure TSimpleThread.StartThread;
begin
  FWaitStop := false;
end;

procedure TSimpleThread.WaitThreadStop;
begin
  // ȴ߳̽
  StopThread;
  Terminate;
  SelfStart;
  WaitFor;
end;

end.
